// sys.h
// header per l' interfaccia offerta dal nucleo e dal modulo di IO
//

#ifndef SYS_H_
#define SYS_H_

#include <tipo.h>
#include <costanti.h>

extern "C" natl activate_p(void f(int), int a, natl prio, natl liv);
extern "C" void terminate_p();
extern "C" natl give_num();
extern "C" void end_program();
extern "C" natl sem_ini(int val);
extern "C" void sem_wait(natl sem);
extern "C" void sem_signal(natl sem);
extern "C" void *mem_alloc(natl dim, natl balign = 2);
extern "C" void mem_free(void *pv);
extern "C" void delay(natl n);
extern "C" void readse_n(natl serial, natb vetti[], natl quanti, natb &errore);
extern "C" void readse_ln(natl serial, natb vetti[], natl &quanti, natb &errore);
extern "C" void writese_0(natl serial, natb vetto[], natl &quanti);
extern "C" void writese_n(natl serial, natb vetto[], natl quanti);
extern "C" bool resident(void* start,  natl quanti, bool residente = true);
extern "C" void dump(natl tipo);

extern "C" natl pci_read(natw l, natw regn, natl size);

const natl VKBD_LED_SCROLLOCK = 1L;
const natl VKBD_LED_NUMLOCK   = 2L;
const natl VKBD_LED_CAPSLOCK  = 4L;

extern "C" void vkbd_wfi(int v);
extern "C" natw vkbd_read(int v);
extern "C" void vkbd_intr_enable(int v, bool enable);
extern "C" void vkbd_switch(int v);
extern "C" void vkbd_send(int v, natw code, bool clear = false);
extern "C" void vkbd_leds(int v, natb led, bool on);
extern "C" void vmon_switch(int v);
extern "C" void vmon_write_n(int v, natl off, natw vetti[], int quanti);
extern "C" void vmon_setcursor(int v, natl off);
extern "C" bool vmon_getsize(int v, natl& maxx, natl& maxy);
extern "C" bool vmon_cursor_shape(int v, int shape);

extern "C" void readlog(log_msg& m);
extern "C" void log(log_sev sev, cstr msg, natl quanti);

extern "C" void iniconsole(natb cc);
extern "C" void readconsole(str buff, natl& quanti);
extern "C" void writeconsole(cstr buff);

/*enum ETH_ERR {
	RX_OK = 0,
	TX_OK = 0,
	RX_ERROR = 1,
	TX_ERROR = 1,
	RX_STATUS_ERROR_OR_WRONG_LEN = 2,
	RX_NOT_ENOUGH_SPACE = 3,
	SYSTEM_ERROR = 10
};*/


extern "C" void eth_receive(int eth_if, natb uvetti[], natl uquanti, ETH_ERR& rx_err);
extern "C" void eth_transmit(int eth_if, natb uvetto[], natl uquanti, ETH_ERR& tx_err);

#endif

